/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

de.ggbs.abs.externalApp=null;
de.ggbs.abs.externalAppHandler=null;

de.ggbs.abs.gCurMabFile=null;

de.ggbs.abs.uploadDone=function() {
  if (!de.ggbs.abs.gABS.noexternalappset) {
    if (de.ggbs.abs.externalApp) {
      var syncprotocol = de.ggbs.abs.gABS.protocol;
      if (de.ggbs.abs.externalApp==-1)
        de.ggbs.abs.pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
      else
        de.ggbs.abs.pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
    }
    if (de.ggbs.abs.externalAppHandler)
      de.ggbs.abs.pref.setCharPref("network.protocol-handler.app."+syncprotocol, de.ggbs.abs.externalAppHandler);
    de.ggbs.abs.externalApp=null;
    de.ggbs.abs.externalAppHandler=null;
  }
}

de.ggbs.abs.upload=function(singleBook, force)
{
//dump('in upload appstart='+de.ggbs.abs.gABS.appstarttime+' state='+de.ggbs.abs.gABS.state+'\n');
  if (typeof(force) == 'object') {  //called via openWindow()
    singleBook=singleBook.data;
    force=force.data=='true';
  } else if (typeof(force) == 'string') {  //called via openWindow() (Since TB3.x?)
    force=force=='true';
  }

  de.ggbs.abs.gLifeTime=3;
  de.ggbs.abs.gForce=force||de.ggbs.abs.gABS.forceUpload;
    de.ggbs.abs.gABS.forceUpload=false;
  var synctype=de.ggbs.abs.gABS.synctype;

  if (de.ggbs.abs.gABS.usesPopup) {
    if (de.ggbs.abs.gABS.exiting && de.ggbs.abs.gABS.hideallpopups) {
      de.ggbs.abs.gLifeTime=1;//if 0, statusmessages are not going into the file
try {
//      var status=document.getElementById('statuswindow');
//      status.collapsed=true;  //resizes the window to about 10x50px!
                              //black in TB3, transparent with border in TB2
      window.moveTo(10000,10000); //with this, only a small part of the window is visible
                                  //at the lower right of the screen
      window.resizeTo(0,0);
} catch(e) { alert(e); }
    }
  }

  de.ggbs.abs.statustxt(synctype, -1, false, 'Start upload ('+synctype+')');

  de.ggbs.abs.gABS.count=0;
  de.ggbs.abs.gMabs=de.ggbs.abs.gABS.syncedAddressbooks('up', singleBook);

  de.ggbs.abs.cleanUp=de.ggbs.abs.uploadDone;
  if (synctype=='local') {
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.sendLocalData, 0);   // give popup time to show up
    else de.ggbs.abs.sendLocalData();
  } else if (synctype=='remote') {
    if (!de.ggbs.abs.gABS.noexternalappset) {
      var syncprotocol = de.ggbs.abs.gABS.protocol;
//dump('setting de.ggbs.abs.externalApp preferences for '+syncprotocol+'\n');
      try { de.ggbs.abs.externalApp=de.ggbs.abs.pref.getBoolPref("network.protocol-handler.external."+syncprotocol) }
        catch(e) { de.ggbs.abs.externalApp=-1; }
      if (de.ggbs.abs.externalApp) de.ggbs.abs.pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
      //ubuntu seems to ignore the value of external.xxx, therefore:
      try {
        de.ggbs.abs.externalAppHandler=de.ggbs.abs.pref.getCharPref("network.protocol-handler.app."+syncprotocol);
        if (de.ggbs.abs.externalAppHandler) de.ggbs.abs.pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
      } catch(e) { de.ggbs.abs.externalAppHandler=''; }
    }
    if (!de.ggbs.abs.checkOffline()) return;
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.sendData, 0);
    else de.ggbs.abs.sendData();
  } else if (synctype=='imap') {
    if (!de.ggbs.abs.checkOffline()) return;
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapSave, 0);
    else de.ggbs.abs.imapSave();
  } else {
    de.ggbs.abs.killMe();
  }

}

de.ggbs.abs.sendLocalData=function() {
  var localpath=de.ggbs.abs.gABS.localpath;
  if (!localpath) { //preferences not set!
    de.ggbs.abs.killMe();
    return;
  }
  var path = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  try {
    path.initWithPath( localpath );
  } catch(e) {
    de.ggbs.abs.killMe();
    de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('failed'), 2, true, null, localpath);
    return;
  }
  while (de.ggbs.abs.gMabs.Count()>0) {
    if (de.ggbs.abs.gAbort) break;
    var dir=de.ggbs.abs.gMabs.GetElementAt(0).QueryInterface(Components.interfaces.nsIAbDirectory);
    de.ggbs.abs.gMabs.RemoveElement(dir);
    var dirProp = de.ggbs.abs.gABS.noDirProp?dir:dir.directoryProperties;
    var mabName=dir.dirName;
    var mabFile=dirProp.fileName;

    var lmd = de.ggbs.abs.getLastModified(dir);
    var lmds='lastMod='+(lmd?de.ggbs.abs.timeString(lmd*1000):'before appstart');
    if (!de.ggbs.abs.gABS.forcedUploadOf(mabFile) &&
        !de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime && de.ggbs.abs.gABS.appstarttime>=lmd) {
      de.ggbs.abs.statustxt('- '+mabName+' '+de.ggbs.abs.gStrings.getString('skipped'), 3, false, null, lmds);
      continue;
    }

    var externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
    externalFilename=externalFilename.replace(/\.ldif?$/i,'.mab');

    de.ggbs.abs.statustxt('- '+mabName+'..', 1, false, null, lmds);
    if (de.ggbs.abs.saveMabFile(mabName, mabFile, path, externalFilename)) {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false);
      de.ggbs.abs.gABS.forceUploadOf(mabFile, false);
      de.ggbs.abs.gABS.count+=1;
    } else {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true);
    }
  }
  de.ggbs.abs.killMe();
}

de.ggbs.abs.sendData=function()
{
    while (true) {
      if (!de.ggbs.abs.gMabs.Count() || de.ggbs.abs.gAbort) {
        de.ggbs.abs.killMe();
        return;
      }
      var dir=de.ggbs.abs.gMabs.GetElementAt(0).QueryInterface(Components.interfaces.nsIAbDirectory);
      de.ggbs.abs.gMabs.RemoveElement(dir);
      var dirProp = de.ggbs.abs.gABS.noDirProp?dir:dir.directoryProperties;
      var mabName=dir.dirName;
      var mabFile=dirProp.fileName;

      var lmd = de.ggbs.abs.getLastModified(dir);
      var lmds='lastMod='+(lmd?de.ggbs.abs.timeString(lmd*1000):'before appstart');
      if (!de.ggbs.abs.gABS.forcedUploadOf(mabFile) &&
          !de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime && de.ggbs.abs.gABS.appstarttime>=lmd) {
        de.ggbs.abs.statustxt('- '+mabName+' '+de.ggbs.abs.gStrings.getString('skipped'), 3, false, null, lmds);
        continue;
      }
      break;
    }
    de.ggbs.abs.gCurMabFile=mabFile
    var externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
    externalFilename=externalFilename.replace(/\.ldif?$/i,'.mab');

    de.ggbs.abs.statustxt('- '+mabName+".", 1, false, null, lmds);  // 1. dot: start

    var mabURI=de.ggbs.abs.getSyncURI(false)+externalFilename;
    var ioService=Components.classes["@mozilla.org/network/io-service;1"]
                   .getService(Components.interfaces.nsIIOService);
    try {//There has been a case, where the 'FTP' was missing (Markus Buscher <blackpanther.online@gmx.de>)
      var URI=ioService.newURI(mabURI,null,null);
    } catch(e) {
      alert('Internal error: URI incomplete');
      de.ggbs.abs.killMe();
      return;
    }

    var nsIMabFile=de.ggbs.abs.gABS.getDir('ProfD');
    nsIMabFile.appendRelativePath( mabFile );
    var abData=de.ggbs.abs.gABS.readMabData(nsIMabFile, de.ggbs.abs.gABS.checkLastModTime);
    if (!abData) {
      de.ggbs.abs.uploadCallback("done",-2); // file does not exist
      return;
    }
    de.ggbs.abs.statustxt(".", 0, false); // 2. dot: file loaded

    var error=de.ggbs.abs.gUploadService.start(abData, URI, 'text/plain', de.ggbs.abs.uploadCallback);
    if(error)
      de.ggbs.abs.uploadCallback("done", error);
    else
      de.ggbs.abs.statustxt(".", 0, false); // 4. dot: upload start is finished
}

de.ggbs.abs.uploadCallback=function(aStatus,aError)
{
  if (aStatus=='send') {  //called from within gUploadService.start
    de.ggbs.abs.statustxt('.', 0, false); // 3. dot: upload started
    return;
  } else {  // upload finished (called with aStatus='done' from grUploadService)
try { de.ggbs.abs.errorstr; } catch(e) { de.ggbs.abs.sendData(); return; }  //bei Upload at onUnload ohne popup fenster
                                                    //existiert hier errorstr() nicht mehr
                                                    //nicht einmal mehr sendData()!
    var error=de.ggbs.abs.errorstr(aError);
    if (error!=de.ggbs.abs.gStrings.getString('ok')) {
      de.ggbs.abs.statustxt(error, 2, true);
      de.ggbs.abs.gLifeTime=5;//in seconds.
//      de.ggbs.abs.killMe();
//      return;
    } else {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('ok'), 2, false);
      de.ggbs.abs.gABS.forceUploadOf(de.ggbs.abs.gCurMabFile, false);
      de.ggbs.abs.gABS.count+=1;
    }
  }

    de.ggbs.abs.sendData(); //next addressbook
}

de.ggbs.abs.cancelUpload=function()
{
  if (de.ggbs.abs.gAbort) {
    de.ggbs.abs.gAbort++;
    de.ggbs.abs.killMe();
  } else {
    de.ggbs.abs.gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  // de.ggbs.abs.gUploadService.cancel();  // no or we may left behind corrupted files
}

